/* *****************************************************************************
 * libg1m/format/mcs/list.h -- description of the MCS list format.
 * Copyright (C) 2017 Thomas "Cakeisalie5" Touhey <thomas@touhey.fr>
 *
 * This file is part of libg1m.
 * libg1m is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3.0 of the License,
 * or (at your option) any later version.
 *
 * libg1m is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with libg1m; if not, see <http://www.gnu.org/licenses/>.
 * ************************************************************************** */
#ifndef LIBG1M_FORMAT_MCS_LIST_H
# define LIBG1M_FORMAT_MCS_LIST_H
# include <libg1m/bcd.h>
# pragma pack(1)

/* Lists start with a header: */

struct mcs_listheader {
	/* probably the title */
	uint8_t title[8];

	/* the elements count */
	uint16_t element_count;

	/* undocumented (always 0?) */
	uint8_t undocumented[5];

	/* undocumented (either 0x00 or 0x4F) */
	uint8_t undocumented2;
};

/* Then there is the list of real parts of the elements.
 * If the complex bit is present on at least one of the elements (highest bit
 * of the first nibble, which is the highest nibble of the exponent), then it
 * is followed by the list of the imaginary parts of the elements.
 *
 * If the imaginary parts is here, only read the imaginary part of an element
 * if his highest bit is set: it might contain complete crap! */

# pragma pack()
#endif /* LIBG1M_FORMAT_MCS_LIST_H */
