/* *****************************************************************************
 * manage/create.c -- create a handle.
 * Copyright (C) 2017 Thomas "Cakeisalie5" Touhey <thomas@touhey.fr>
 *
 * This file is part of libg1m.
 * libg1m is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3.0 of the License,
 * or (at your option) any later version.
 *
 * libg1m is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with libg1m; if not, see <http://www.gnu.org/licenses/>.
 * ************************************************************************** */
#include <libg1m/internals.h>

/**
 *	g1m_make_mcs:
 *	Make an MCS file.
 *
 *	@arg	h		pointer to the handle to create.
 *	@return			the error code (0 if ok).
 */

int g1m_make_mcs(g1m_t **h)
{
	/* allocate the handle */
	*h = malloc(sizeof(g1m_t));
	if (!*h) return (g1m_error_alloc);

	/* initialize it */
	g1m_t *handle = *h;
	handle->type = g1m_type_mcs;
	handle->platform = g1m_platform_fx;
	handle->count = 0;
	handle->_size = 0;
	handle->files = NULL;

	/* no error */
	return (0);
}
